//+------------------------------------------------------------------+
//|                                 Boston Market Signal_v 01.1.mq4  |
//|                           Copyright 2018 Bostonmarket@gmail.com  |
//|                                                                  | 
//|                  Boston Market Signal-With Alerts                |  
//|                                                                  |
//| Version 01.1  Completed 2018 (www.Forex-joy.com)                 |
//|                                                                  |
//|               a)   Complete Code rewrite                         |
//|               b)   Added Entry / Exit Signal Arrows Option       | 
//|               b)   Added Audio, Visual and eMail alerts          | 
//|                                                                  |
//|         GIFTS AND DONATIONS ACCEPTED                             | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |  
//+------------------------------------------------------------------+                                                                  |

#property copyright "Copyright 2018 Boston Market CO USA"
#property link      "http://www.Forex-joy.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 WhiteSmoke
#property indicator_color2 WhiteSmoke
#property indicator_width1 3
#property indicator_width2 3

//+------------------------------------------------------------------+
//|                                                                  |
//| input properties                                                 | 
//|                                                                  |  
//+------------------------------------------------------------------+

extern int  dist2           = 14;
extern int  dist1           = 50;
extern bool AlertsOn        = false;
extern bool AlertsOnCurrent = false;
extern bool AlertsMessage   = false;
extern bool AlertsSound     = false;
extern bool AlertsEmail     = false;

//---- buffers
double b1[];
double b2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 {
   SetIndexBuffer(0,b1);
   SetIndexBuffer(1,b2);
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID);
   SetIndexArrow(0,226);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID);
   SetIndexArrow(1,225);

  return(0);
 }
//+------------------------------------------------------------------+
//|                                                                  | 
//|         Boston Market Signal                                     |
//|                                                                  |
//|                                                                  |  
//+------------------------------------------------------------------+

 int start()
 {
   int counted_bars=IndicatorCounted();
   int i,limit,hhb,llb,hhb1,llb1;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           limit=MathMax(limit,dist1);
           limit=MathMax(limit,dist2);
//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |  
//+------------------------------------------------------------------+
   for (i=limit;i>=0;i--)
      {
         hhb1 = Highest(NULL,0,MODE_HIGH,dist1,i-dist1/2);
         llb1 = Lowest(NULL,0,MODE_LOW,dist1,i-dist1/2);
         hhb  = Highest(NULL,0,MODE_HIGH,dist2,i-dist2/2);
         llb  = Lowest(NULL,0,MODE_LOW,dist2,i-dist2/2);

            b1[i] = EMPTY_VALUE;
            b2[i] = EMPTY_VALUE;
           
      
         double tr = iATR(NULL,0,50,i);
         if (i==hhb)  b1[i]=High[hhb] +tr;
         if (i==llb)  b2[i]=Low[llb]  -tr;
         
      }
      
//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |  
//+------------------------------------------------------------------+
   
   if (AlertsOn)
      {
         int forBar = 1;
            if (AlertsOnCurrent) forBar = 0;
            if (b1[forBar] != EMPTY_VALUE ) doAlert("Strong Sell!");
            if (b2[forBar] != EMPTY_VALUE ) doAlert("Strong Buy!");
            
      }
  return(0);
} 

//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |  
//+------------------------------------------------------------------+
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   string TimePeriod;
   
   if (Period()== 1)       TimePeriod = "M1";
   if (Period()== 5)       TimePeriod = "M5";
   if (Period()== 15)      TimePeriod = "M15";
   if (Period()== 30)      TimePeriod = "M30";
   if (Period()== 60)      TimePeriod = "H1";
   if (Period()== 240)     TimePeriod = "H4";
   if (Period()== 1440)    TimePeriod = "D1";
   if (Period()== 10080)   TimePeriod = "W1";
   if (Period()== 43200)   TimePeriod = "MN";

      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |  
//+------------------------------------------------------------------+

          message =  StringConcatenate(Symbol(),"  ", TimePeriod, " Boston Market Signal: ",doWhat);
             if (AlertsMessage) Alert(message);
             if (AlertsEmail)   SendMail(StringConcatenate(Symbol()," Boston Market Signal: "),message);
             if (AlertsSound)   PlaySound("wait.wav");
      }
}